//*****************************************************************************
//*
//*		GetIp.cpp
//*
//*****************************************************************************
#pragma	comment(lib, "wsock32.lib")

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <time.h>

#define 	MIB_IF_TYPE_OTHER		1
#define 	MIB_IF_TYPE_ETHERNET 	6
#define 	MIB_IF_TYPE_TOKEN_RING 	9
#define 	MIB_IF_TYPE_FDDI 		15
#define 	MIB_IF_TYPE_PPP 		23
#define 	MIB_IF_TYPE_LOOPBACK 	24
#define 	MIB_IF_TYPE_SLIP 		28

#define		MAX_ADAPTER_NAME_LENGTH			256
#define 	MAX_ADAPTER_DESCRIPTION_LENGTH	128
#define 	MAX_ADAPTER_ADDRESS_LENGTH		8


typedef struct 
	{  
	char String[4 * 4];
	}IP_ADDRESS_STRING, *PIP_ADDRESS_STRING, IP_MASK_STRING, *PIP_MASK_STRING;
	
	
typedef struct _IP_ADDR_STRING
	{  
	struct _IP_ADDR_STRING* Next;  
	IP_ADDRESS_STRING		IpAddress;  
	IP_MASK_STRING			IpMask;  
	DWORD					Context;
	} IP_ADDR_STRING, *PIP_ADDR_STRING;


typedef struct _IP_ADAPTER_INFO 
	{
	struct _IP_ADAPTER_INFO *Next;						
	DWORD			ComboIndex;									  
	char			AdapterName[MAX_ADAPTER_NAME_LENGTH + 4];		 
	char 			Description[MAX_ADAPTER_DESCRIPTION_LENGTH + 4];
	UINT 			AddressLength;									 
	BYTE 			Address[MAX_ADAPTER_ADDRESS_LENGTH];			 
	DWORD 			Index;										 
	UINT 			Type;											 
	UINT 			DhcpEnabled;									 
	PIP_ADDR_STRING CurrentIpAddress;					 
	IP_ADDR_STRING	IpAddressList;						 
	IP_ADDR_STRING	GatewayList;
	IP_ADDR_STRING	DhcpServer;
	BOOL 			HaveWins;
	IP_ADDR_STRING	PrimaryWinsServer;
	IP_ADDR_STRING	SecondaryWinsServer;
	time_t 			LeaseObtained;
	time_t 			LeaseExpires; 
	}IP_ADAPTER_INFO, *PIP_ADAPTER_INFO;


typedef DWORD (_stdcall * GetAdInfo)(PIP_ADAPTER_INFO,PULONG);


static	GetAdInfo	 get_info=0;
static	HMODULE		 hIphlpApi=0;


//*****************************************************************************
//*
//*		GetAdaptersInfo
//*
//*****************************************************************************
DWORD GetAdaptersInfo(  PIP_ADAPTER_INFO pAdapterInfo,  PULONG pOutBufLen)
{

	if(!hIphlpApi)
		{
		hIphlpApi=LoadLibrary("iphlpapi.dll");
		}

	if(!hIphlpApi)return ERROR_NOT_SUPPORTED;
	if(!get_info)get_info=(GetAdInfo)GetProcAddress(hIphlpApi,"GetAdaptersInfo");
	if(!get_info)return ERROR_NOT_SUPPORTED;


return get_info(pAdapterInfo,pOutBufLen);
}

//*****************************************************************************
//*
//*		read_mac
//*
//*****************************************************************************
//	Anzeigen der MAC-Addressen 
//	Diese Funktion zeigt auch die IP-Addresse einer Modem-Verbindung an (PPP)	
void read_mac()
{
PIP_ADDR_STRING		pAddressList;
PIP_ADAPTER_INFO	pInfo=0;
unsigned long		ulLen=0;
int					nError,i;
char				cText[256];

	nError = GetAdaptersInfo(pInfo,&ulLen);
	
	if(nError==ERROR_NO_DATA)
		{
		printf("\nNo adapter information exists for the local computer");
		}

	if(nError==ERROR_NOT_SUPPORTED)
		{
		printf("\nGetAdaptersInfo is not supported by the operating system running on the local computer");
		}

	if(nError==ERROR_BUFFER_OVERFLOW)
		{
		pInfo  = (PIP_ADAPTER_INFO)new char[ulLen];
		nError = GetAdaptersInfo(pInfo,&ulLen);
		}

	if(nError==0)
	while(pInfo)		
		{
		strncpy(cText,pInfo->Description,sizeof(cText));
		cText[sizeof(cText)-1]=0;

		for(i=0;cText[i];i++)
			{
			if(cText[i]>0 && cText[i]<' ')cText[i]=' ';
			}
		for(i--;i>0;i--)
			{
			if(cText[i]!=' ')break;
			cText[i]=0;
			}

		printf("\nDescription:   %s",cText);
		printf("\nType:          %i",pInfo->Type);
		if(pInfo->Type==MIB_IF_TYPE_PPP)printf(" Modem");
		if(pInfo->Type==MIB_IF_TYPE_ETHERNET)printf(" Ethernet");
		
		
		printf("\nMAC-Address:   %02X:%02X:%02X:%02X:%02X:%02X",pInfo->Address[0],pInfo->Address[1],pInfo->Address[2],pInfo->Address[3],pInfo->Address[4],pInfo->Address[5]);
		
		
		pAddressList = &(pInfo->IpAddressList);
		 
		while(pAddressList != NULL)
			{
			if(pAddressList->IpAddress.String)
				printf("\nIP-Address:    %s",pAddressList->IpAddress.String);
			pAddressList = pAddressList->Next;
			}

		printf("\nSubnet-Mask:   %s",pInfo->IpAddressList.IpMask.String);
		printf("\nGateway:       %s",pInfo->GatewayList.IpAddress.String);
		printf("\n\n");

		pInfo = pInfo->Next;
		}


	if(pInfo)delete pInfo;	
}

//*****************************************************************************
//*
//*		read_ip
//*
//*****************************************************************************
void read_ip()
{
int     err,x;
WORD    wVersionRequested;
WSADATA wsaData;
hostent *he;
char	puffer[256];
char	**aliases;
char	**addeses;


	wVersionRequested = MAKEWORD( 2, 0 );
	err =   WSAStartup( wVersionRequested, &wsaData );


	gethostname(puffer,sizeof(puffer));
	printf("\nHostname:\t%s",puffer);

	he=gethostbyname(puffer);
 
	aliases=he->h_aliases;
	addeses=he->h_addr_list;

	for(x=0;x<256;x++)
		{
		if(!aliases[x])break;
		printf("\nAlias %i:\t%s",x,aliases[x]);
		}

	for(x=0;x<256;x++)
		{
		if(!addeses[x]){printf(" -> %s",addeses[x-1]+4);break;}
		printf("\nIP-Addres %i:\t%i.%i.%i.%i",x+1,	addeses[x][0]&0xFF,
													addeses[x][1]&0xFF,
													addeses[x][2]&0xFF,
													addeses[x][3]&0xFF);
		}

	WSACleanup();

}

//*****************************************************************************
//*
//*		main
//*
//*****************************************************************************
int main()
{			 

	printf("\n\n\nRead IP-Addresses ...\n");
 	read_ip();

	printf("\n\n\nRead MAC-Addresses ...\n");
 	read_mac();

	getch();

return 0;
}